unit player;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  SkinData, DynamicSkinForm, ExtCtrls, Menus, spTrayIcon, ImgList, SkinHint;

type
  TForm1 = class(TForm)
    DSF: TspDynamicSkinForm;
    spSkinData1: TspSkinData;
    Timer1: TTimer;
    PopupMenu1: TPopupMenu;
    Loadskin1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    OD: TOpenDialog;
    spSkinData2: TspSkinData;
    spTrayIcon1: TspTrayIcon;
    Close1: TMenuItem;
    MinimizeToTrauy1: TMenuItem;
    N2: TMenuItem;
    Stop1: TMenuItem;
    Stop2: TMenuItem;
    ImageList1: TImageList;
    spSkinHint1: TspSkinHint;
    procedure FormCreate(Sender: TObject);
    procedure DSFMouseDownEvent(IDName: String; X,
      Y: Integer; ObjectRect: TRect; Button: TMouseButton);
    procedure Timer1Timer(Sender: TObject);
    procedure DSFChangeSkinData(Sender: TObject);
    procedure DSFMouseUpEvent(IDName: String; X, Y: Integer;
      ObjectRect: TRect; Button: TMouseButton);
    procedure Loadskin1Click(Sender: TObject);
    procedure DSFTrackBarChangeValueEvent(IDName: String; Value: Integer);
    procedure DSFSwitchChangeStateEvent(IDName: String;
      State: TSwitchState);
    procedure Exit2Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure DSFFrameRegulatorChangeValueEvent(IDName: String;
      Value: Integer);
    procedure MinimizeToTrauy1Click(Sender: TObject);
    procedure Stop1Click(Sender: TObject);
    procedure Stop2Click(Sender: TObject);
    procedure DSFMinimizeToTray(Sender: TObject);
    procedure DSFRestoreFromTray(Sender: TObject);
    procedure Close1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure LoadSkin(FileName: String);
  end;

var
  Form1: TForm1;

implementation

uses AboutUnit;
var
  Stereo: Boolean;
  FPlayBarPosition: Integer;
  
{$R *.DFM}

procedure TForm1.LoadSkin;
var
  SkinPath: String;
begin
  spSkinData1.LoadFromFile(FileName);
  SkinPath := ExtractFilePath(FileName);
  spSkinData2.LoadFromFile(SkinPath + 'skin.in1');
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Path: String;
begin
  Path := ExtractFilePath(ParamStr(0));
  LoadSkin(Path + 'skins\default\skin.ini');
  Stereo := False;
  FPlayBarPosition := 0;
  OD.InitialDir := Path; 
end;

procedure TForm1.DSFMouseDownEvent(IDName: String; X,
  Y: Integer; ObjectRect: TRect; Button: TMouseButton);
var
  i: Integer;
begin
  if (IDName = 'PlayButton') or
     (IDName = 'ru_PlayButton')
  then
    begin
      Timer1.Enabled := True;
      DSF.AnimateStart('PlayAnimate');
    end
  else
    if (IDName = 'StopButton') or
       (IDName = 'PauseButton') or
       (IDName = 'ru_PauseButton') or
       (IDName = 'ru_StopButton')
    then
      begin
        Timer1.Enabled := False;
        DSF.AnimateStop('PlayAnimate');
        for i := 1 to 11 do
          DSF.GaugeSetValue('Chanel' + IntToStr(i), 0);
      end;  
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
  i: Integer;
begin
  for i := 1 to 11 do
    DSF.GaugeSetValue('Chanel' + IntToStr(i), Random(100));
  DSF.TrackBarSetValue('PlayBar', DSF.TrackBarGetValue('PlayBar') + 1);
end;

procedure TForm1.DSFChangeSkinData(Sender: TObject);
begin
  with DSF do
  begin
    FrameGaugeSetValue('framegauge', 10);
    FrameRegulatorSetValue('frameregulator', 10);
    TrackBarSetValue('PlayBar', FPlayBarPosition);
    TrackBarSetValue('VolumeBar', 50);
    TrackBarSetValue('BalanceBar', 50);
    LinkMenu('MenuButton', PopupMenu1, True);
    if Stereo
    then
      begin
        SwitchSetState('MonoStereoSwitch', swsOn);
        DSF.BitLabelSetText('MonoStereoLabel', 'stereo');
      end
    else
      DSF.BitLabelSetText('MonoStereoLabel', 'mono');
  end;
end;

procedure TForm1.DSFMouseUpEvent(IDName: String; X, Y: Integer;
  ObjectRect: TRect; Button: TMouseButton);
begin
  if IDName = 'LoadButton'
  then DSF.BitLabelSetText('FileName', 'techno-music.mp3')
  else
  if IDName = 'LeftButton'
  then
    DSF.TrackBarSetValue('PlayBar', DSF.TrackBarGetValue('PlayBar') - 10)
  else
  if IDName = 'RightButton'
  then
    DSF.TrackBarSetValue('PlayBar', DSF.TrackBarGetValue('PlayBar') + 10);
end;

procedure TForm1.Loadskin1Click(Sender: TObject);
var
  B: Boolean;
begin
  if OD.Execute
  then
    begin
      B := Timer1.Enabled;
      FPlayBarPosition := DSF.TrackBarGetValue('PlayBar');
      Timer1.Enabled := False;
      LoadSkin(OD.FileName);
      //
      if B
      then
        begin
          Timer1.Enabled := True;
          DSF.AnimateStart('PlayAnimate');
          DSF.ButtonSetDown('PlayButton', True);
        end;
     end;
end;

procedure TForm1.DSFTrackBarChangeValueEvent(IDName: String;
  Value: Integer);
var
  i: Integer;
  S: String;
begin
  if IDName = 'PlayBar'
  then
    begin
      if Value = 100
      then
        if DSF.SwitchGetState('RepeatSwitch') = swsOn
        then
          DSF.TrackBarSetValue('PlayBar', 0)
        else
          begin
            Timer1.Enabled := False;
            DSF.AnimateStop('PlayAnimate');
            for i := 1 to 11 do
              DSF.GaugeSetValue('Chanel' + IntToStr(i), 0);
            DSF.ButtonSetDown('StopButton', True);
            DSF.ButtonSetDown('ru_StopButton', True);
            if spTRayIcon1.CycleIcons
            then
              begin
                spTRayIcon1.CycleIcons := False;
                spTRayIcon1.IconIndex := 0;
              end;
            spTRayIcon1.CycleIcons := False;
          end;
      S := IntToStr(Round(35 * Value / 100));
      if Length(S) = 1 then S := '0' + S;
      DSF.BitLabelSetText('Secs', S);
      DSF.BitLabelSetText('ru_Secs', S);
    end;
end;

procedure TForm1.DSFSwitchChangeStateEvent(IDName: String;
  State: TSwitchState);
begin
  if (IDName = 'MonoStereoSwitch')
  then
    if State = swsOn then
    begin
      DSF.BitLabelSetText('MonoStereoLabel', 'stereo');
      Stereo := True;
    end
  else
    begin
      Stereo := False;
      DSF.BitLabelSetText('MonoStereoLabel', 'mono');
    end;
end;

procedure TForm1.Exit2Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.N1Click(Sender: TObject);
begin
  AboutForm.Show;
end;

procedure TForm1.DSFFrameRegulatorChangeValueEvent(IDName: String;
  Value: Integer);
begin
  DSF.FrameGaugeSetValue('framegauge',
    DSF.FrameRegulatorGetValue('frameregulator'));
end;

procedure TForm1.MinimizeToTrauy1Click(Sender: TObject);
begin
  DSF.MinimizeToTray;
end;

procedure TForm1.Stop1Click(Sender: TObject);
begin
  Timer1.Enabled := True;
  DSF.AnimateStart('PlayAnimate');
end;

procedure TForm1.Stop2Click(Sender: TObject);
var
  i: Integer;
begin
  Timer1.Enabled := False;
  DSF.AnimateStop('PlayAnimate');
  for i := 1 to 11 do
    DSF.GaugeSetValue('Chanel' + IntToStr(i), 0);
end;

procedure TForm1.DSFMinimizeToTray(Sender: TObject);
begin
  if Timer1.Enabled then spTRayIcon1.CycleIcons := True;
end;

procedure TForm1.DSFRestoreFromTray(Sender: TObject);
begin
  spTRayIcon1.CycleIcons := False;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

end.
